Index: encoder/slicetype.c
===================================================================
--- encoder/slicetype.c	(Revision 606)
+++ encoder/slicetype.c	(Arbeitskopie)
@@ -292,6 +292,12 @@
                 i_score += x264_slicetype_mb_cost( h, a, frames, p0, p1, b, dist_scale_factor );
     }
 
+    /* reset mv bounds */
+    h->mb.mv_min_fpel[0] = h->mb.mv_max_fpel[0] =
+    h->mb.mv_min_spel[0] = h->mb.mv_max_spel[0] =
+    h->mb.mv_min_fpel[1] = h->mb.mv_max_fpel[1] =
+    h->mb.mv_min_spel[1] = h->mb.mv_max_spel[1] = 0;
+
     if( b != p1 )
         i_score = i_score * 100 / (120 + h->param.i_bframe_bias);
 
Index: encoder/analyse.c
===================================================================
--- encoder/analyse.c	(Revision 606)
+++ encoder/analyse.c	(Arbeitskopie)
@@ -310,14 +310,18 @@
 /* Max = 4 */
 static void predict_16x16_mode_available( unsigned int i_neighbour, int *mode, int *pi_count )
 {
-    if( i_neighbour & MB_TOPLEFT )
+    if( (i_neighbour & (MB_LEFT|MB_TOP)) == (MB_LEFT|MB_TOP) )
     {
         /* top and left available */
         *mode++ = I_PRED_16x16_V;
         *mode++ = I_PRED_16x16_H;
         *mode++ = I_PRED_16x16_DC;
-        *mode++ = I_PRED_16x16_P;
-        *pi_count = 4;
+        *pi_count = 3;
+        if( i_neighbour & MB_TOPLEFT )
+        {
+	    *mode++ = I_PRED_16x16_P;
+	    *pi_count = 4;
+        }
     }
     else if( i_neighbour & MB_LEFT )
     {
@@ -344,14 +348,18 @@
 /* Max = 4 */
 static void predict_8x8chroma_mode_available( unsigned int i_neighbour, int *mode, int *pi_count )
 {
-    if( i_neighbour & MB_TOPLEFT )
+    if( (i_neighbour & (MB_LEFT|MB_TOP)) == (MB_LEFT|MB_TOP) )
     {
         /* top and left available */
         *mode++ = I_PRED_CHROMA_V;
         *mode++ = I_PRED_CHROMA_H;
         *mode++ = I_PRED_CHROMA_DC;
-        *mode++ = I_PRED_CHROMA_P;
-        *pi_count = 4;
+        *pi_count = 3;
+        if( i_neighbour & MB_TOPLEFT )
+        {
+	    *mode++ = I_PRED_CHROMA_P;
+	    *pi_count = 4;
+        }
     }
     else if( i_neighbour & MB_LEFT )
     {
